unit WinAdd;

{$IMPORTEDDATA OFF}

interface

uses Windows;

type
  DWORDLONG = Int64; // XXX Delphi 6 not supported unsigned 64bit integer
  UINT_PTR = Cardinal;
  USHORT = Word;

  TMemoryStatusEx = packed record
    dwLength: DWORD;
    dwMemoryLoad: DWORD;
    ullTotalPhys: DWORDLONG;
    ullAvailPhys: DWORDLONG;
    ullTotalPageFile: DWORDLONG;
    ullAvailPageFile: DWORDLONG;
    ullTotalVirtual: DWORDLONG;
    ullAvailVirtual: DWORDLONG;
    ullAvailExtendedVirtual: DWORDLONG;
  end;

  TWaveFormatEx = packed record
    wFormatTag: Word;
    nChannels: Word;
    nSamplesPerSec: DWORD;
    nAvgBytesPerSec: DWORD;
    nBlockAlign: Word;
    wBitsPerSample: Word;
    cbSize: Word;
  end;
  PWaveFormatEx = ^TWaveFormatEx;

  TReparseDataBuffer = record
    ReparseTag: ULONG;
    ReparseDataLength: USHORT;
    Reserved: USHORT;
    case Integer of
      0: (SymbolicLinkReparseBuffer: record
            SubstituteNameOffset: USHORT;
            SubstituteNameLength: USHORT;
            PrintNameOffset: USHORT;
            PrintNameLength: USHORT;
            Flags: ULONG;
            PathBuffer: array [0..0] of WCHAR;
          end);
      1: (MountPointReparseBuffer: record
            SubstituteNameOffset: USHORT;
            SubstituteNameLength: USHORT;
            PrintNameOffset: USHORT;
            PrintNameLength: USHORT;
            PathBuffer: array [0..0] of WCHAR;
          end);
      2: (DataBuffer: array [0..0] of UCHAR);
  end;
  PReparseDataBuffer = ^TReparseDataBuffer;

const
  STARTF_TITLEISLINKNAME = $00000800;

  IO_REPARSE_TAG_MOUNT_POINT = $a0000003;
  IO_REPARSE_TAG_SYMLINK = $a000000c;

  FILE_ATTRIBUTE_REPARSE_POINT = $400;

  FILE_FLAG_OPEN_REPARSE_POINT = $200000;
  FILE_DEVICE_FILE_SYSTEM = 9;
  FILE_ANY_ACCESS = 0;
  METHOD_BUFFERD = 0;
  FSCTL_GET_REPARSE_POINT = FILE_DEVICE_FILE_SYSTEM shl 16 or
      FILE_ANY_ACCESS shl 14 or 42 shl 2 or METHOD_BUFFERD;

  WPF_ASYNCWINDOWPLACEMENT = $0004;

  CLEARTYPE_QUALITY = 5;

  EVENT_CONSOLE_UPDATE_REGION = $4002;
  EVENT_CONSOLE_UPDATE_SIMPLE = $4003;

  // URL moniker errors
  INET_E_RESOURCE_NOT_FOUND = $800c0005;
  INET_E_OBJECT_NOT_FOUND = $800c0006;
  INET_E_DOWNLOAD_FAILURE = $800c0008;

  // wFormatTag IDs
  WAVE_FORMAT_UNKNOWN  = $0000;
  WAVE_FORMAT_PCM = $0001;
  WAVE_FORMAT_ADPCM = $0002;
  WAVE_FORMAT_WMAVOICE9 = $000a;
  WAVE_FORMAT_MPEG = $0050;
  WAVE_FORMAT_MPEGLAYER3 = $0055;
  WAVE_FORMAT_DOLBY_AC3_SPDIF = $0092;
  WAVE_FORMAT_RAW_AAC1 = $00ff;
  WAVE_FORMAT_MSAUDIO1 = $0160;
  WAVE_FORMAT_WMAUDIO2 = $0161;
  WAVE_FORMAT_WMAUDIO3 = $0162;
  WAVE_FORMAT_WMAUDIO_LOSSLESS = $0163;
  WAVE_FORMAT_MPEG_ADTS_AAC = $1600;
  WAVE_FORMAT_DVM = $2000;
  WAVE_FORMAT_OGG_VORBIS_MODE_1 = $674f;
  WAVE_FORMAT_OGG_VORBIS_MODE_2 = $6750;
  WAVE_FORMAT_OGG_VORBIS_MODE_3 = $6751;
  WAVE_FORMAT_OGG_VORBIS_MODE_1_PLUS = $676f;
  WAVE_FORMAT_OGG_VORBIS_MODE_2_PLUS = $6770;
  WAVE_FORMAT_OGG_VORBIS_MODE_3_PLUS = $6771;
  WAVE_FORMAT_OPUS = $704f;
  WAVE_FORMAT_FLAC = $f1ac;

function GetFileSizeEx(hFile: THandle; var FileSize: LARGE_INTEGER): BOOL;
    stdcall; external kernel32 name 'GetFileSizeEx';
function SetFilePointerEx(hFile: THandle; DistanceToMove: LARGE_INTEGER;
    var NewFilePointer: LARGE_INTEGER; MoveMethod: DWORD): BOOL;
    stdcall; external kernel32 name 'SetFilePointerEx';

function GlobalMemoryStatusEx(var MemoryStatusEx: TMemoryStatusEx): BOOL;
    stdcall; external kernel32 name 'GlobalMemoryStatusEx';

function GetConsoleWindow: HWND; stdcall; external kernel32;

// fix Windows unit declaration bug
function GetDiskFreeSpaceExW(lpDirectoryName: PWideChar;
    lpFreeBytesAvailableToCaller, lpTotalNumberOfBytes,
    lpTotalNumberOfFreeBytes: PULargeInteger): BOOL;
    stdcall; external kernel32 name 'GetDiskFreeSpaceExW';
function LoadCursorW(hInstance: HINST; lpCursorName: PWideChar): HCURSOR;
    stdcall; external user32 name 'LoadCursorW';

implementation
end.
